#include "stdafx.h"
#include "hklm.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CApp : public CWinApp
{
public:
	CApp();

	//{{AFX_VIRTUAL(CApp)
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CApp::CApp()
{
}

CApp theApp;

BOOL CApp::InitInstance()
{
  //Test out all the methods of CHKLM
	CHKLM hklm;

  //Set the name of the Company
	hklm.SetRegistryKey(_T("PJ Naughter"));
	hklm.SetRegistryKey(IDS_PJ_NAUGHTER);

  //Test the string persistance functions
  CString sSection(_T("Test Section"));
	BOOL bSuccess   = hklm.WriteProfileString(sSection, _T("Test String"), _T("Test string value"));
	CString sString = hklm.GetProfileString(sSection, _T("Dummy Test String"), _T("Default Get String"));
	sString         = hklm.GetProfileString(sSection, _T("Test String"));

	//Test the integer persistance functions
	bSuccess    = hklm.WriteProfileInt(sSection, _T("Test Int"), 33);
	UINT nValue = hklm.GetProfileInt(sSection, _T("Dummy Test Int"), 0);
	nValue      = hklm.GetProfileInt(sSection, _T("Test Int"), 0);

	//Test the blob persistance functions
	char* pData = "1234567890";
	bSuccess = hklm.WriteProfileBinary(sSection, _T("Test Blob"), (LPBYTE) pData, (DWORD) strlen(pData));
  LPBYTE pRetrievedData;
	UINT nBytes;
	bSuccess = hklm.GetProfileBinary(sSection, _T("Unknown Test Blob"), &pRetrievedData, &nBytes);
	bSuccess = hklm.GetProfileBinary(sSection, _T("Test Blob"), &pRetrievedData, &nBytes);
	delete [] pRetrievedData;

  //Test the string array methods
  CStringArray array;
  array.SetAtGrow(0, _T("First String"));
  array.SetAtGrow(1, _T("Second and Last String"));
  bSuccess = hklm.WriteProfileStringArray(sSection, _T("Test StringArray"), array);

  array.SetSize(0);
  bSuccess = hklm.GetProfileStringArray(sSection, _T("Test StringArray"), array); 
  bSuccess = hklm.GetProfileStringArray(sSection, _T("Unknown StringArray"), array);

  return FALSE;
}
